/* C libraries */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Tags */
#define XMAX	10	/* Max X */
#define YMAX	10	/* Max Y */
#define FLOWERS 20	/* Number of flowers */

int main()
{

	/* Variables declaration and init */

	char	meadow[XMAX][YMAX],	/* Array that represents the meadow shown on video*/
			move;				/* Player move (f=flag to signal a possible flower, u=uncover a box) */

	int		map[XMAX][YMAX];	/* Hidden map */

	int		x=0,y=0,					/* Coordinates */
			i=0,j=0,k=0,di=0,dj=0,go=0,	/* Indexes and counters */
			flower=0,					/* End of the game (loosing) */
			win=0;						/* End of the game (winning) */
	
	/* Init on video */
	for(i=0;i<XMAX;i++)
		for(j=0;j<YMAX;j++) meadow[i][j]='#';

	/* Init hidden map */
	for(i=0;i<XMAX;i++)
		for(j=0;j<YMAX;j++) map[i][j]=0;

	/* Random placement of flower (with a check only on the total number!) */

	srand( (unsigned) time(0) );	/* Pseudo-random init of random numbers generator */
 	
	j=0;
	do
	{
		x= rand()%XMAX;	/* random row */
		y= rand()%YMAX;	/* random column */

		if (map[x][y]==0)	/* If no flower */
		{
			map[x][y]=1;	/* Flower */
			j++;			/* Number of flower ++ */
		} 
	}while(j<FLOWERS);


	/* Main loop */
	
	do
	{

		/* Show meadow on screen */

		printf("\n\n        ");
		for(i=0;i<YMAX;i++) printf("%2d",i);
		printf("\n         ");

		for(i=0;i<YMAX;i++) printf("--",i);
		printf("\n");

		for(i=0;i<XMAX;i++)
		{
			printf("     %2d|", i);
			for(j=0;j<YMAX;j++) printf("%2c",meadow[i][j]);
			printf(" |\n");
		}

		printf("         ");
		for(i=0;i<YMAX;i++) printf("--",i);

		printf("\n\n");

		/* 	FOR DEBUG ONLY: show flowers 
		
				printf("\n\n        ");
				for(i=0;i<YMAX;i++) printf("%3d",i);
				printf("\n");
		
				for(i=0;i<XMAX;i++)
				{
					printf("     %3d", i);
					for(j=0;j<YMAX;j++) printf("%3d",map[i][j]);
					printf("\n");
				}
		
				printf("\n\n");
		*/

		/* Get user move */

		do
		{
			printf("\nInsert next move ((f|u) x y): ");
			scanf("%c %d %d%*c", &move, &x, &y);
		}while( (x<0) || (x>=XMAX) || (y<0) || (y>=YMAX) || ((move!='f')&&(move!='u')) );

		/* Check user move */

		if (move=='f') meadow[x][y]='!';	/* Update meadow on screen */
		else
		{
			if (map[x][y]==1)	/* Check flower */
			{
				flower=1; /* If flower then loose! */
				meadow[x][y]='o';
			}				
			else meadow[x][y]='*'; /* '*' is a tag to be used later */
		}

		/* Check adjacency (if not win/loose)*/
		if ((flower!=1)&&(win!=1)) /* I'm not sure it is needed the check also on win */
		{	
			do
			{
				go=0; /* Used to repeat the do-while */
				for(i=0; i<XMAX; i++)
					for(j=0; j<YMAX; j++)
					{
						k=0;	/* Counter of adjacent flowers */
	
						if (meadow[i][j]=='*') /* If box uncovered */
						{
							go=1; /* Since I have found a '*' it will be needed another do-while loop */
							for(di=-1; di<2; di++)
								for(dj=-1; dj<2; dj++)
								{
									if ( (i+di>=0) && (i+di<XMAX) &&
									     (j+dj>=0) && (j+dj<YMAX)
									   )
									   if (map[i+di][j+dj]==1) k++;
								}
						
							/* Empty propagation */
							if(k==0)
							{
								for(di=-1; di<2; di++)
									for(dj=-1; dj<2; dj++)
									{
										if ( (i+di>=0) && (i+di<XMAX) &&
										     (j+dj>=0) && (j+dj<YMAX) &&
										     ((di!=0)||(dj!=0)) 
										   )
										   if (meadow[i+di][j+dj]!=' ')
										   	meadow[i+di][j+dj]='*'; /* To be processed in the next do-while loop */
									}
							}
								
							/* Insert adjacency values */
							switch(k)
							{
								case 0: meadow[i][j]=' '; break;
								case 1: meadow[i][j]='1'; break;
								case 2: meadow[i][j]='2'; break;
								case 3: meadow[i][j]='3'; break;
								case 4: meadow[i][j]='4'; break;
								case 5: meadow[i][j]='5'; break;
								case 6: meadow[i][j]='6'; break;
								case 7: meadow[i][j]='7'; break;
								case 8: meadow[i][j]='8'; break;
							}
						}
					}
			}while(go==1);		
		}

		/* Count the number of covered boxes */
	
		k=0;
		for(i=0; i<XMAX; i++)
			for(j=0; j<YMAX; j++)
				if ((meadow[i][j]=='#')||(meadow[i][j]=='!')) k++;
	
		if (k==FLOWERS) win=1;

	}while((flower==0)&&(win==0));

	if (flower==1) printf("\n\nYOU LOOSE!\n");
	else printf("\n\nYOU WIN!!!\n");
 	
	/* Final view */

	printf("\n\n        ");
	for(i=0;i<YMAX;i++) printf("%2d",i);
	printf("\n         ");

	for(i=0;i<YMAX;i++) printf("--",i);
	printf("\n");

	for(i=0;i<XMAX;i++)
	{
		printf("     %2d|", i);
		for(j=0;j<YMAX;j++)
			if (map[i][j]==1) printf("%2c",'o');
			else printf("%2c", meadow[i][j]);
		printf(" |\n");
	}

	printf("         ");
	for(i=0;i<YMAX;i++) printf("--",i);

	printf("\n\n");

	system("pause");
	
	return 0;
}
